
/************************************************************************/
#ifndef _INC_ICAPI
#define _INC_ICAPI    /* #defined if ICWINAPI.H has been included    */

#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************/
#ifndef SYSAPI
    #ifdef WIN32
		#define SYSAPI WINAPI
    #else
		#define SYSAPI FAR PASCAL WINAPI _export
	#endif
#endif

#ifndef CALLBACKAPI
    #ifdef WIN32
		#define CALLBACKAPI CALLBACK
    #else
		#define CALLBACKAPI CALLBACK _export
	#endif
#endif

/***************************************************************************/

#define WPICAPIRET unsigned long

#define WPICAPI_MAX_STRING_LENGTH		32766  /* approx 32K limit for  */
										       /* each parameter        */
#define WPICAPI_MAX_STRING_LENGTH_STR 	"32766"

/*------------------------------------------------------------------------
* Valid flags for the CategoryInfo field for WPICCategoryInfoGet
*-----------------------------------------------------------------------*/
#define WPICAPIFLAG_ALLFIELDINFO "#ALLFIELDINFO"

/*------------------------------------------------------------------------
* Valid Options for WPICiBaseObject
*-----------------------------------------------------------------------*/
#define IC_IBASE_INFORMATION			 "1"
#define IC_IBASE_BACKUP					 "2"
#define IC_IBASE_RESTORE				 "3"
#define IC_IBASE_REMOTECHECKOUT			 "4"
#define IC_IBASE_REMOTECHECKIN			 "5"
#define IC_IBASE_REMOTEABONDON			 "6"
#define IC_IBASE_OPEN					 "7"
#define IC_IBASE_COPY					 "8"
#define IC_IBASE_MOVE					 "9"
#define IC_IBASE_DELETE					"10"

#define IC_IBASECOMPRESSED_NEW			"15"
#define IC_IBASECOMPRESSED_RESTORE		"16"
#define IC_IBASECOMPRESSED_COPY			"17"

#define IC_PRINT_ADDRESSBOOK			"20"
#define IC_PRINT_CALENDARINFO			"21"

#define IC_MACRO_RUN    				"30"
#define IC_MACRO_EDIT   				"31"
#define IC_MACRO_COMPILE				"32"
#define IC_MACRO_DELETE 				"33"
#define IC_MACRO_COPY   				"34"
#define IC_MACRO_MOVE   				"35"

/*------------------------------------------------------------------------
* Valid flags for WPICMacroExecute
*-----------------------------------------------------------------------*/
#define WPIC_MACROEXECUTE_FOCUSTOAPP  	"2"
#define WPIC_MACROEXECUTE_FOCUSTOWPIC  	"5"

/*------------------------------------------------------------------------
* The following flags are left here for compatibility with previous
* Beta versions of the SDK.  Do not use these values as they are both
* equivalent to WPIC_MACROEXECUTE_FOCUSTOAPP and are obsolete.
*-----------------------------------------------------------------------*/
#define WPIC_MACROEXECUTE_SYNCRONOUS 	WPIC_MACROEXECUTE_FOCUSTOAPP
#define WPIC_MACROEXECUTE_ASYNCRONOUS  	WPIC_MACROEXECUTE_FOCUSTOAPP

/*------------------------------------------------------------------------
* Values returned from WPICErrorGetLast.
*-----------------------------------------------------------------------*/

#define WPICAPI_NO_ERROR					      1
#define WPICAPI_ERROR						      2

#define WPICAPIERROR_BUFFER_INPUTOVERFLOW 	     10
#define WPICAPIERROR_BUFFER_OUTPUTOVERFLOW	     11
#define WPICAPIERROR_OUT_OF_MEMORY        	     12

#define WPICAPIERROR_DLLLOAD_WPICHOOK 		   	100
#define WPICAPIERROR_DLLLOAD_WPICOTHER		   	101

#define WPICAPIERROR_INFOCENTRAL_START	       	110

#define WPICAPIERROR_REGDATABASE      	       	120

#define WPICAPIERROR_IBASENOTFOUND			   	130
#define WPICAPIERROR_PASSWORDINVALID		   	140

#define WPICAPIERROR_CATEGORY  					151
#define WPICAPIERROR_DIDCANCEL  				152
#define WPICAPIERROR_FILE_ERROR					153
#define WPICAPIERROR_DATA_ERROR 				154
#define WPICAPIERROR_EMAIL_NOTFOUND 			155

/*--------------------------------------------------------------------------
* Values used for WPICAPISETTINGS.fFlags
*-------------------------------------------------------------------------*/
#define WPICAPI_SETTINGS_DEFAULT 				0
#define WPICAPI_SETTINGS_SENDRETCODETOWINDOW	1

/*--------------------------------------------------------------------------
*
*-------------------------------------------------------------------------*/
#define WPICAPI_PERFECTFITENABLED  "/PFON"
#define WPICAPI_PERFECTFITDISABLED "/PFOFF"

/*--------------------------------------------------------------------------
* Maximum number of InfoCentral entries per major version
* in the registration database
*-------------------------------------------------------------------------*/
#define WPICAPI_MAX_VERSION_ENTRIES	20

/*--------------------------------------------------------------------------
* File extensions registered with the system shell
*-------------------------------------------------------------------------*/
#define ICWShelliBaseExt		".ICA"
#define ICWShelliBaseZipExt		".ZIB"
#define ICWShellMacroSrcExt 	".MAC"
#define ICWShellMacroExeExt 	".MXE"

/**************************************************************************
* structures
**************************************************************************/

typedef struct tagWPICAPISETTINGS
	{
	unsigned long	cbThisData;
    unsigned long 	cbMaxStrLen;
	unsigned long	fFlags;
	HWND			hWndForRetCode;
	UINT			MsgForRetCode;
	char 			Delimiter[2];
    char 			APIFileName[_MAX_PATH];
	} WPICAPISETTINGS;

/**************************************************************************
* Function prototypes
**************************************************************************/

WPICAPIRET SYSAPI WPICInfoCentralStart( LPSTR fOptions
									  , LPSTR InfoCentralOptions);

WPICAPIRET SYSAPI WPICShellObject( LPSTR Option
								 , LPSTR ObjectName
								 , LPSTR OptionalTarget);

WPICAPIRET SYSAPI WPICShellObjectPrintTo(LPSTR ObjectName
										,LPSTR PrinterName
										,LPSTR PrinterDriver
										,LPSTR PrinterPort);

WPICAPIRET SYSAPI WPICiBaseOpen(LPSTR iBaseName
							   ,LPSTR Password);

WPICAPIRET SYSAPI WPICiBaseSave(void);

WPICAPIRET SYSAPI WPICiBaseGetCurrent(LPSTR iBaseName);

WPICAPIRET SYSAPI WPICCategoryInfoGet(LPSTR pCategoryName
				     				 ,LPSTR FieldNames		);

WPICAPIRET SYSAPI WPICConnectionInfoRead(LPSTR ConnectionID
				     					,LPSTR FieldNames		);

WPICAPIRET SYSAPI WPICConnectionAdd(LPSTR PrimaryObjectID
				     			   ,LPSTR SecondaryObjectID
				     			   ,LPSTR PrimaryRelationship
				     			   ,LPSTR SecondaryRelationship
				     			   ,LPSTR FieldValues
				     			   ,LPSTR ConnectionID        );

WPICAPIRET SYSAPI WPICConnectionLocate(LPSTR PrimaryType
				     				  ,LPSTR SecondaryType
				     				  ,LPSTR PrimaryRelationship
				     				  ,LPSTR SecondaryRelationship
									  ,LPSTR ObjectID
				     				  ,LPSTR NumFound
				     				  ,LPSTR ConnectionIDs	);

WPICAPIRET SYSAPI WPICConnectionRead(LPSTR ConnectionID
				     				,LPSTR FieldNames
				     				,LPSTR FieldValues		);

WPICAPIRET SYSAPI WPICConnectionUpdate(LPSTR ConnectionID
				     				  ,LPSTR FieldValues		);

WPICAPIRET SYSAPI WPICObjectAdd(LPSTR CategoryName
				     		   ,LPSTR FieldValues
				     		   ,LPSTR ObjectID				);

WPICAPIRET SYSAPI WPICObjectLocate(LPSTR CategoryName
				     			  ,LPSTR ObjectName
				     			  ,LPSTR NumFound
				     			  ,LPSTR ObjectIDs   			);

WPICAPIRET SYSAPI WPICObjectRead(LPSTR ObjectID
				     			,LPSTR FieldNames
								,LPSTR FieldValues			);

WPICAPIRET SYSAPI WPICObjectUpdate(LPSTR ObjectID
				     			  ,LPSTR FieldValues			);

WPICAPIRET SYSAPI WPICSettings(LPSTR Delimiter
							  ,LPSTR APIFileName
							  ,LPSTR MaxStringLen);

WPICAPIRET SYSAPI WPICSettingsEx(WPICAPISETTINGS * pSettings);

WPICAPIRET SYSAPI WPICTokenGet(LPSTR StringOfTokens
				     		  ,LPSTR TokenIdx
				     		  ,LPSTR Token						);

WPICAPIRET SYSAPI WPICErrorGetLast(WPICAPIRET far * pLastErrorCode);

WPICAPIRET SYSAPI WPICGroupWiseImportExport
									  (LPSTR DaysPrior
									  ,LPSTR DaysAfter
									  ,LPSTR ImportAppointments
									  ,LPSTR ImportTasks
									  ,LPSTR ExportAppointments
									  ,LPSTR ExportTasks				);

WPICAPIRET SYSAPI WPICMacroExecute(LPSTR pMacroName
								  ,LPSTR pfOptions);
#ifdef __cplusplus
}
#endif
/***************************************************************************/
#endif // _INC_ICAPI
